import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import java.io.*;
import javax.microedition.io.*;

import org.jorgecardoso.net.HTTPRedirect;
import org.jorgecardoso.net.URLEncoder;

public class HTTPGETParametro extends MIDlet implements Runnable, CommandListener {

	private final static String URLBASE = "http://jorgecardoso.org/misc/anagrama.php?palavra=";

	private Alert espera;
	private Gauge indicador;

    private Form palavraForm;
    private TextField palavraText;

    private TextBox resultado;
    private TextBox headers;

	private Command cmdSair, cmdBuscar, cmdIncio, cmdHeaders, cmdResultado, cmdCancelar;

	private Thread threadCorrente = null;

	private String url;

    public HTTPGETParametro() {


      	palavraText = new TextField("Palavra", "midp", 255, TextField.ANY);
      	palavraForm = new Form("Anagrama");
      	palavraForm.append(palavraText);
		resultado = new TextBox("Resultado", "", 256, TextField.ANY);
		headers = new TextBox("Headers HTTP", "", 256, TextField.ANY);

      	indicador = new Gauge(null, false, Gauge.INDEFINITE, 0);
      	espera = new Alert("A Descarregar");
      	espera.setIndicator(indicador);
      	espera.setTimeout(Alert.FOREVER);

      	cmdSair = new Command("Sair", Command.EXIT, 1);
      	cmdBuscar = new Command("Buscar", Command.SCREEN, 1);
      	cmdIncio = new Command("Incio", Command.SCREEN, 2);
      	cmdHeaders = new Command("Headers", Command.SCREEN, 2);
      	cmdResultado = new Command("Resultado", Command.SCREEN, 2);
      	cmdCancelar = new Command("Cancelar", Command.CANCEL, 1);

      	palavraForm.addCommand(cmdSair);
      	palavraForm.addCommand(cmdBuscar);
      	palavraForm.setCommandListener(this);

      	resultado.addCommand(cmdSair);
      	resultado.addCommand(cmdIncio);
      	resultado.addCommand(cmdHeaders);
      	resultado.setCommandListener(this);

      	headers.addCommand(cmdSair);
      	headers.addCommand(cmdIncio);
      	headers.addCommand(cmdResultado);
      	headers.setCommandListener(this);

		espera.addCommand(cmdCancelar);
		espera.setCommandListener(this);
    }

    public void startApp() {
		System.out.println("StartApp");
      	Display.getDisplay(this).setCurrent(palavraForm);
    }

	public void destroyApp(boolean unconditional) {
		pararThread();
	}

	public void pauseApp() {
		System.out.println("PauseApp");
	}

	public void commandAction(Command c, Displayable d) {
		if (c == cmdSair) {
			destroyApp(true);
			notifyDestroyed();
		} else if (c == cmdCancelar) {
			pararThread();
			Display.getDisplay(this).setCurrent(palavraForm);
		/**/} else if (c == cmdBuscar) {
			Display.getDisplay(this).setCurrent(espera);
			url = palavraText.getString();
			threadCorrente = new Thread(this);
			threadCorrente.start();/**/
		} else if (c == cmdIncio) {
			Display.getDisplay(this).setCurrent(palavraForm);
		} else if (c == cmdHeaders) {
			Display.getDisplay(this).setCurrent(headers);
		} else if (c == cmdResultado) {
			Display.getDisplay(this).setCurrent(resultado);
		}
	}

	/**/private void pararThread() {
		Thread t = threadCorrente;

		threadCorrente = null;
		if (t != null) {
			try {
				t.join();
			} catch (InterruptedException ie) {
				System.err.println("Excepo:" + ie.getMessage());
			}
		}
	}/**/

	/**/public void run() {
		Thread estaThread = Thread.currentThread();

		HttpConnection c = null;
		InputStream is = null;

		if (estaThread != threadCorrente) {
			return;
		}

		indicador.setValue(Gauge.INCREMENTAL_UPDATING);
		try {

			url = URLBASE + URLEncoder.encode(palavraText.getString());
			System.out.println(estaThread + ":" + url);
			c = (HttpConnection)Connector.open(url);

			/* ler os cabealhos HTTP		*/
			String field, key;
			StringBuffer texto = new StringBuffer();
			int i = 0;
			do {
				field = c.getHeaderField(i);
				key = c.getHeaderFieldKey(i);

				i++;
				if (key != null) {
					texto.append(key).append(":").append(field).append("\n");
					System.out.println(key + ":" + field);
				}
			} while (key != null);

			/* colocar os cabealhos na caixa de texto	*/
			if (texto.length() > 0) {
				headers.setMaxSize(texto.length());
				headers.setString(texto.toString());
			} else {
				headers.setString("");
			}

			/* indicar progresso						*/
			indicador.setValue(Gauge.INCREMENTAL_UPDATING);

			/* verificar se o utilizador cancelou		*/
			if (estaThread != threadCorrente) {
				return;
			}

			/* ler o corpo da resposta HTTP				*/
			is = c.openInputStream();

			/* 	se soubermos o tamanho da resposta, podemos tentar ler tudo
				de uma s vez.
			*/
			int len = (int) c.getLength();
			texto = new StringBuffer();
			if (len > 0) {
				int actual = 0;
				int byteslidos = 0;
				byte [] dados = new byte[len];

				while ((byteslidos != len) && (actual != -1)) {
					actual = is.read(dados, byteslidos, len-byteslidos);

					byteslidos += actual;

					/* verificar cancelamento e indicar progresso	*/
					if (estaThread != threadCorrente) {
						return;
					}
					indicador.setValue(Gauge.INCREMENTAL_UPDATING);
				}

				texto.append(new String(dados));

			} else {
				/* 	no sabemos o tamanho da resposta, por isso,
					vamos ler aos bocados at terminar.
				*/
				byte [] dados = new byte[256];

				int actual = 0;
				while ( actual != -1 ) {
					actual = is.read(dados, 0, 256);

					if (actual != -1) {
						texto.append(new String(dados, 0, actual));
					}

					/* verificar cancelamento e indicar progresso	*/
					if (estaThread != threadCorrente) {
						return;
					}
					indicador.setValue(Gauge.INCREMENTAL_UPDATING);
				}


			}

			/* 	se o corpo da mensagem tiver algum contedo, vamos
				afix-lo na caixa de texto 'resultado'. Se no
				vamos limpar a caixa de texto.
			*/
			if (texto.length() > 0) {
				resultado.setMaxSize(texto.length());
				resultado.setString(texto.toString());
			} else {
				resultado.setString("");
			}


		} catch(ClassCastException cce) {
			System.err.println("Excepo:" + cce.getMessage());
		} catch (IOException ioe) {
			System.err.println("Excepo:" + ioe.getMessage());
		} finally {
			/* 	libertar os recursos, mesmo que tenha havido
				uma excepo.
			*/
			try {
				if (is != null) {
					is.close();
				}
				if (c != null) {
					c.close();
				}
			} catch (IOException ioe) {
			}
		}

		/* mostrar o resultado	*/
		Display.getDisplay(this).setCurrent(resultado);
	}/**/
}